/*************************************************
 **                                             **
 **   ndx.h                                     **
 **                                             **
 **          Copyright (C) 1988-1992 by         **
 **               SoftC, Ltd.                   **
 **               16820 3rd St NE               **
 **               Anoka, MN 55304               **
 **               (612) 434-6968                **
 **                                             **
 **             All rights reserved.            **
 *************************************************/



#ifndef __SOFTC_H__
#include "softc.h"
#endif



/**********
 *
 *  Type Definitions
 *
 **********/




typedef struct {  /* dBASE index file information packet */
  CHAR fname[80]; /* file name */
  SC_FLAGS flags; /* miscellaneous flags */
  INT keylen;     /* key length */
  INT keytype;    /* key type ('C' Character, 'N' Date/Numeric) */
  INT keyfmt;     /* key format (Unique) */
  INT lockt;      /* file locked/unlocked flag */
  INT exprlen;    /* key expression length */
  CHAR expr[100]; /* first 100 characters of the index expression */
} SC_NDXINFO;







#ifdef __ANSI_PROTOTYPES__
#ifdef __cplusplus
extern "C" {
#endif


/**********
 *
 *  dBASE III+ Index File Manipulators Prototypes
 *
 **********/




INT PROTOS scdnbfrsz(  INT,              /* index file handle */
		       INT F_PTR,        /* buffer length in pages */
		       INT );            /* set or get buffer length */

INT PROTOS scdnclose(  INT );            /* file handle */

INT PROTOS scdncreate( CHAR F_PTR,       /* filename */
		       INT,              /* index key type */
		       CHAR F_PTR,       /* key expression */
		       INT );            /* key length */

INT PROTOS scdnexpr(   INT,              /* file handle */
		       CHAR F_PTR );     /* key expression */

INT PROTOS scdnflush(  INT );            /* file handle */

INT PROTOS scdnhget(   INT );            /* file handle */

INT PROTOS scdnindex(  INT,              /* data file handle */
		       CHAR F_PTR,       /* new file name */
		       INT,              /* index key type */
		       CHAR F_PTR,       /* key expression */
		       INT );            /* key length */

INT PROTOS scdninfo(   INT,              /* file handle */
		       SC_NDXINFO F_PTR );/* file information and status */

INT PROTOS scdnlock(   INT );            /* file handle */

INT PROTOS scdnopenx(  INT F_PTR,        /* file handle */
		       CHAR F_PTR,       /* filename */
		       INT );            /* open mode and characteristics */

INT PROTOS scdnunlock( INT );            /* file handle */





/**********
 *
 *  dBASE III+ Index Key Building Prototypes
 *
 **********/




INT PROTOS scdnkdate(  CHAR F_PTR,       /* numeric date */
		       CHAR F_PTR,       /* date string */
		       INT );            /* date string format type */

INT PROTOS scdnkmake(  INT,              /* .DBF file handle */
		       INT,              /* .NDX file handle */
		       VOID F_PTR F_PTR);/* index key */

INT PROTOS scdnknum(   CHAR F_PTR,       /* dBASE numeric key */
		       DOUBLE );         /* C DOUBLE */





/**********
 *
 *  dBASE III+ Index Key Manipulator Prototypes
 *
 **********/




INT PROTOS scdnkadd(   INT,              /* file handle */
		       VOID F_PTR,       /* key string */
		       LONG );           /* data record number */

INT PROTOS scdnkbot(   INT,              /* file handle */
		       VOID F_PTR,       /* key string */
		       LONG F_PTR);      /* data record number */

INT PROTOS scdnkcur(   INT,              /* file handle */
		       VOID F_PTR,       /* key string */
		       LONG F_PTR);      /* data record number */

INT PROTOS scdnkdel(   INT,              /* file handle */
		       VOID F_PTR,       /* key string */
		       LONG );           /* data record number */

INT PROTOS scdnkfind(  INT,              /* file handle */
		       VOID F_PTR,       /* key string */
		       LONG F_PTR,       /* data record number */
		       INT);             /* exact match or first */

INT PROTOS scdnknext(  INT,              /* file handle */
		       VOID F_PTR,       /* key string */
		       LONG F_PTR);      /* data record number */

INT PROTOS scdnkprev(  INT,              /* file handle */
		       VOID F_PTR,       /* key string */
		       LONG F_PTR);      /* data record number */

INT PROTOS scdnktop(   INT,              /* file handle */
		       VOID F_PTR,       /* key string */
		       LONG F_PTR);      /* data record number */





#ifdef __cplusplus
}
#endif
#endif



